import string


# Function to encrypt a message using Caesar cipher
def caesar_encrypt(plaintext, shift):
    alphabet = string.ascii_uppercase
    shifted_alphabet = alphabet[shift:] + alphabet[:shift]
    table = str.maketrans(alphabet, shifted_alphabet)
    return plaintext.translate(table)


# Function to decrypt Caesar cipher with a given shift
def caesar_decrypt(ciphertext, shift):
    alphabet = string.ascii_uppercase
    shifted_alphabet = alphabet[-shift:] + alphabet[:-shift]
    table = str.maketrans(alphabet, shifted_alphabet)
    return ciphertext.translate(table)


if __name__ == '__main__':

    # Example message to encrypt
    message = "THIS IS A SECRET MESSAGE THAT IS EASY TO BREAK"
    shift = 7  # The secret key

    # Encrypting the message
    ciphertext = caesar_encrypt(message.upper(), shift)

    print(f"Plain-text message (unknown to the attacker): {message}")
    print(f"Encrypted Message: {ciphertext}")


    # Frequency Analysis Function
    def frequency_analysis_attack(ciphertext):

        # Try all possible shifts and rank them by similarity to English frequency
        # English letter frequency (approximate)
        english_freq = "ETAOINSHRDLCUMWFGYPBVKJXQZ"
        potential_decryptions = []
        for shift in range(26):
            decrypted_text = caesar_decrypt(ciphertext, shift)
            score = sum(english_freq.index(char) for char in decrypted_text if char in english_freq)
            potential_decryptions.append((score, shift, decrypted_text))

        # Sort the results by score (lower is better)
        potential_decryptions.sort()

        # Display the top 3 most likely decryptions
        for score, shift, text in potential_decryptions[:3]:
            print(f"Shift: {shift}")
            print(f"Decrypted Message: {text}")
            print(f"Score: {score}\n")

    # Attempt to crack the cipher
    frequency_analysis_attack(ciphertext)
