import base64
import json

#----------------------------------------------------------------
# URL with "encoded" API key (False sense of security)
#----------------------------------------------------------------

api_key = "my_secret_api_key"
encoded_api_key = base64.b64encode(api_key.encode()).decode()

url = f"http://example.com/api?key={encoded_api_key}"
print(f"Insecure URL: {url}")


#----------------------------------------------------------------
# Encoding important files as Base64
#----------------------------------------------------------------
with open("Resources/config.xml", "rb") as file:
    file_data = file.read()

encoded_file = base64.b64encode(file_data).decode()
print(f"Encoded File Data (Insecure): {encoded_file[:100]}...")


#----------------------------------------------------------------
# Encoding API KEYS as Base64
#----------------------------------------------------------------

encoded_key = "dXNlcm5hbWU6cGFzc3dvcmQxMjM="
decoded_key = base64.b64decode(encoded_key).decode()
print(f"Decoded API Key: {decoded_key}")

#----------------------------------------------------------------
# Encoding browser sessions as Base64
#----------------------------------------------------------------

session_data = {
    "username": "admin",
    "role": "administrator"
}
session_str = json.dumps(session_data)
encoded_session = base64.b64encode(session_str.encode()).decode()
print(f"Encoded Cookie Value: {encoded_session}")