from flask import Flask, request, render_template, make_response
import time
import secrets
import sqlite3
import random

app = Flask(__name__)

# Initialize a simple SQLite database
def init_db():
    conn = sqlite3.connect("users.db")
    cursor = conn.cursor()
    # Create a users table
    cursor.execute("""
        CREATE TABLE IF NOT EXISTS users (
            id INTEGER PRIMARY KEY AUTOINCREMENT,
            username TEXT UNIQUE,
            password TEXT
        )
    """)
    # Add a default user for testing
    cursor.execute("INSERT OR IGNORE INTO users (username, password) VALUES (?, ?)", ("janedoe", "123456"))
    cursor.execute("INSERT OR IGNORE INTO users (username, password) VALUES (?, ?)", ("andrea", "iloveyou"))
    cursor.execute("INSERT OR IGNORE INTO users (username, password) VALUES (?, ?)", ("admin", "letmein"))
    conn.commit()
    conn.close()


def generate_insecure_token():
    """Generate an insecure session token with low randomness."""
    # Use predictable random values (not cryptographically secure)
    timestamp = int(time.time())  # Current timestamp
    rand_part = random.randint(0, 1000)  # Very small range for random values
    token = f"{timestamp}-{rand_part}"  # Combine timestamp and random part
    return token


def generate_secure_token():
    """Generate a secure session token with high randomness."""
    return secrets.token_hex(16) # Will look like: 'f9bf78b9a18ce6d46a0cd2b0b86df9da'

@app.route("/", methods=["GET"])
def index():
    return render_template("login.html", message="")

@app.route("/login", methods=["GET", "POST"])
def login():

    if request.method == "GET":
        return render_template("login.html", message="")

    username = request.form.get("username")
    password = request.form.get("password")

    # Perform authentication (deliberately weak)
    conn = sqlite3.connect("users.db")
    cursor = conn.cursor()

    # This is deliberately vulnerable to SQL injection
    # Try with payload: hacker' OR 1=1;--
    # Password is irrelevant, put anything
    cursor.execute(f"SELECT * FROM users WHERE username = '{username}' AND password = '{password}'")
    user = cursor.fetchone()

    # Remediation: Use parameterized queries
    # cursor.execute("SELECT * FROM users WHERE username = ? AND password = ?", (username, password))

    # Check if the user exists
    cursor.execute("SELECT 1 FROM users WHERE username = ?", (username,))
    username_exists = cursor.fetchone()
    conn.close()

    if user:
        # Generate an insecure token
        #token = generate_insecure_token()
        token = generate_secure_token()

        # Return token in a cookie
        response = make_response(render_template("welcome.html", username=username))
        response.set_cookie("session", token)
        response.set_cookie("isadmin", "False")

        # Deliberately remove Content-Security-Policy header to make the application vulnerable to XSS
        response.headers.pop("Content-Security-Policy", None)
        return response
    else:
        if username_exists:
            message = "Invalid password. Try again."
        else:
            message = "Invalid credentials. Try again."

        return render_template("login.html", message=message)


@app.route("/admin", methods=["GET", "POST"])
def admin():

    if request.method == "GET":
        return render_template("admin.html", message="")

    username = request.form.get("username")
    password = request.form.get("password")

    conn = sqlite3.connect("users.db")
    cursor = conn.cursor()
    # This is not vulnerable to SQL injection
    cursor.execute("SELECT * FROM users WHERE username = ? AND password = ?", (username, password))
    user = cursor.fetchone()
    conn.close()

    # Check if the user exists
    conn = sqlite3.connect("users.db")
    cursor = conn.cursor()
    cursor.execute("SELECT * FROM users WHERE username = ?", (username,))
    username_exists = cursor.fetchone()
    conn.close()

    if user and request.cookies.get("isadmin") == "True":

        # Return token in a cookie
        response = make_response(render_template("supersecret.html", username=username))
        return response
    else:
        return render_template("admin.html", message="Not authorized.")


@app.route("/config.xml", methods=["GET"])
def config():
    # Simulated configuration file containing an API key
    response = make_response(
        f"""<?xml version="1.0" encoding="UTF-8"?>
                <config>
                    <apiKey>12345-ABCDE-67890-FGHIJ</apiKey>
                    <environment>production</environment>
                </config>
        """, 200
    )
    response.headers["Content-Type"] = "application/xml"
    return response


if __name__ == "__main__":
    init_db()  # Initialize the database with a default user
    app.run(host="0.0.0.0", port=5001, debug=False)  # Debug mode for testing